Index: /main/trunk/greenstone3/src/java/org/greenstone/admin/gui/ConfPane.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/admin/gui/ConfPane.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/admin/gui/ConfPane.java	(revision 25635)
@@ -81,5 +81,5 @@
 
 	protected JPanel main_contentPane = null;
-	public Hashtable conf_table;
+	public Hashtable<Object, Object> conf_table;
 
 	/** The panel that contains a Conf_list */
@@ -158,5 +158,5 @@
 
 	//An array to store all the details in the build.properties file
-	private ArrayList conf_array;
+	private ArrayList<String> conf_array;
 
 	//Site configuration
@@ -172,5 +172,5 @@
 	public ConfPane()
 	{
-		conf_table = new Hashtable();
+		conf_table = new Hashtable<Object, Object>();
 		// create all the control button panes
 		inner_control_pane = new JPanel();
@@ -652,5 +652,5 @@
 	{
 		String new_string;
-		Enumeration keys = conf_table.keys();
+		Enumeration<Object> keys = conf_table.keys();
 		String key;
 		String value;
@@ -662,5 +662,5 @@
 			for (int j = 0; j < conf_array.size(); j++)
 			{
-				if (((String) conf_array.get(j)).startsWith(key.toLowerCase()))
+				if (conf_array.get(j).startsWith(key.toLowerCase()))
 				{
 					new_string = key + "=" + value;
@@ -719,5 +719,5 @@
 		 * store all the details from the build.properties
 		 */
-		conf_array = new ArrayList();
+		conf_array = new ArrayList<String>();
 		conf_setting = new Object[rowLength][colLength];
 		try
Index: /main/trunk/greenstone3/src/java/org/greenstone/admin/gui/LogPane.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/admin/gui/LogPane.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/admin/gui/LogPane.java	(revision 25635)
@@ -93,5 +93,5 @@
     private JPanel control_pane = null;
 
-    private ArrayList logFiles = new ArrayList();
+    private ArrayList<File> logFiles = new ArrayList<File>();
     private File currentlySelectedFile = null;
       
@@ -387,5 +387,5 @@
 		    //no selection
 		} else if (log_list.getSelectedIndex () == 0 ) {
-		    File log_file = (File)logFiles.get(0);
+		    File log_file = logFiles.get(0);
 		    currentlySelectedFile = log_file;
 		    String filename = log_file.getPath();
@@ -394,5 +394,5 @@
 		    clear_button.setEnabled(true);
 		} else if (log_list.getSelectedIndex () == 1) {
-		    File log_file = (File)logFiles.get(1);
+		    File log_file = logFiles.get(1);
 		    currentlySelectedFile = log_file;
 		    String filename = log_file.getPath();
Index: /main/trunk/greenstone3/src/java/org/greenstone/admin/gui/SetServerPane.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/admin/gui/SetServerPane.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/admin/gui/SetServerPane.java	(revision 25635)
@@ -84,5 +84,5 @@
     ServerSettingTableModel server_setting_table_model = null;
     private boolean setting_confirm = false;
-    private ArrayList conf_array;
+    private ArrayList<String> conf_array;
     private boolean success = false;
     private boolean file_saved = true;
@@ -251,5 +251,5 @@
 	    if (!server_setting_table_model.getValueAt(i,1).toString().matches("^\\s*$")){
 		for (int j=0; j < conf_array.size(); j++){
-		    if (((String)conf_array.get(j)).startsWith(server_setting_table_model.getValueAt(i,0).toString().toLowerCase())){
+		    if (conf_array.get(j).startsWith(server_setting_table_model.getValueAt(i,0).toString().toLowerCase())){
 			//System.err.println("What is the value in conf_array:" + conf_array.get(j));
 			new_string = server_setting_table_model.getValueAt(i,0).toString()+"="+server_setting_table_model.getValueAt(i,1).toString();
@@ -265,5 +265,5 @@
 	String fileLine;
 	/*conf_array[] store all the details from the build.properties*/
-	conf_array = new ArrayList();
+	conf_array = new ArrayList<String>();
 	try {
 	    BufferedReader conf_in = new BufferedReader(new FileReader(filename));
Index: /main/trunk/greenstone3/src/java/org/greenstone/admin/guiext/Command.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/admin/guiext/Command.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/admin/guiext/Command.java	(revision 25635)
@@ -15,5 +15,5 @@
 public class Command implements Runnable
 {
-    HashMap _osCommands = new HashMap();
+    HashMap<String, String> _osCommands = new HashMap<String, String>();
     CommandStep _parent = null;
 
@@ -133,5 +133,5 @@
 	String currentos = System.getProperty("os.name");
 
-	String command = (String)_osCommands.get(currentos);
+	String command = _osCommands.get(currentos);
 	if(command != null){
 	    return command;
@@ -139,5 +139,5 @@
 	
 	if(currentos.contains("Windows")){
-	    command = (String)_osCommands.get("Windows");
+	    command = _osCommands.get("Windows");
 	    
 	    if(command != null){
@@ -145,5 +145,5 @@
 	    }   
 	}
-	return (String)_osCommands.get("default");
+	return _osCommands.get("default");
     }
 
Index: /main/trunk/greenstone3/src/java/org/greenstone/admin/guiext/CommandStep.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/admin/guiext/CommandStep.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/admin/guiext/CommandStep.java	(revision 25635)
@@ -27,5 +27,5 @@
 public class CommandStep extends Step
 {
-    protected ArrayList _commandsAndCallbacks = new ArrayList();
+    protected ArrayList<Runnable> _commandsAndCallbacks = new ArrayList<Runnable>();
     protected LoggedMessageArea _messageArea = new LoggedMessageArea(this.getClass());
     protected int _threadCount = -1;
@@ -85,5 +85,5 @@
 
 	    _threadCount = 0;
-	    Thread newThread = new Thread((Runnable)_commandsAndCallbacks.get(0));
+	    Thread newThread = new Thread(_commandsAndCallbacks.get(0));
 	    newThread.start();
 	}
@@ -106,5 +106,5 @@
 
 	if(_threadCount < _commandsAndCallbacks.size()){
-	    Thread newThread = new Thread((Runnable)_commandsAndCallbacks.get(_threadCount));
+	    Thread newThread = new Thread(_commandsAndCallbacks.get(_threadCount));
 	    newThread.start();
 	}
Index: /main/trunk/greenstone3/src/java/org/greenstone/admin/guiext/DownloadStep.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/admin/guiext/DownloadStep.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/admin/guiext/DownloadStep.java	(revision 25635)
@@ -123,5 +123,5 @@
 	    String defaultDownloadLocation = GAI.getGSDL3ExtensionHome() + System.getProperty("file.separator") + fileStem;
 
-	    ArrayList sourceElements = new ArrayList();
+	    ArrayList<Source> sourceElements = new ArrayList<Source>();
 	    sourceElements.add(_mainSource);
 
@@ -134,5 +134,5 @@
 	    for(int i = 0; i < sourceElements.size(); i++){
 		
-		Source currentSource = (Source)sourceElements.get(i);
+		Source currentSource = sourceElements.get(i);
 		String destinationFolder = null;
 
Index: /main/trunk/greenstone3/src/java/org/greenstone/admin/guiext/ExtPane.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/admin/guiext/ExtPane.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/admin/guiext/ExtPane.java	(revision 25635)
@@ -79,5 +79,5 @@
     protected DefaultMutableTreeNode top = new DefaultMutableTreeNode("Extension List");
     
-    protected HashMap extensionInformation = null;
+    protected HashMap<String, ArrayList> extensionInformation = null;
       
     protected JPanel extensionContentHeaderPane = null;
@@ -97,5 +97,5 @@
     
     protected Element extFileRootElement = null;
-    protected HashMap extensions = null;
+    protected HashMap<String, ExtensionInformation> extensions = null;
     protected HashMap extClasses = null;
     protected Properties dependencies = new Properties();
@@ -119,5 +119,5 @@
 	current_description_pane = new JPanel();
 	extensionContentHeaderPane = new JPanel();
-	extensionInformation = new HashMap();
+	extensionInformation = new HashMap<String, ArrayList>();
 
 	// Extension_Pane
@@ -137,5 +137,5 @@
 	Element[] extensionElements = ExtXMLHelper.getMultipleChildElements(extFileRootElement, ExtXMLHelper.EXTENSION, true);
 	if(extensionElements != null){
-	    extensions = new HashMap();
+	    extensions = new HashMap<String, ExtensionInformation>();
 
 	    for(int i = 0; i < extensionElements.length; i++){
@@ -153,12 +153,12 @@
          	
 	load_Admin_UI();
-	HashMap projectNameMap = getProjectList();
-    	Set s = projectNameMap.keySet();
-    	Iterator it = s.iterator();
+	HashMap<String, ArrayList<String>> projectNameMap = getProjectList();
+    	Set<String> s = projectNameMap.keySet();
+    	Iterator<String> it = s.iterator();
     	int i = 0;
     	
 	while(it.hasNext()){
-	    String projectNameGroup = (String)it.next(); 
-	    ArrayList alist = (ArrayList)projectNameMap.get(projectNameGroup);
+	    String projectNameGroup = it.next(); 
+	    ArrayList alist = projectNameMap.get(projectNameGroup);
 	    DefaultMutableTreeNode projecti = new DefaultMutableTreeNode (projectNameGroup);
 	    
@@ -243,7 +243,7 @@
     }
     
-    protected HashMap getProjectList(){
-    	
-	HashMap projectGroupMap = new HashMap();
+    protected HashMap<String, ArrayList<String>> getProjectList(){
+    	
+	HashMap<String, ArrayList<String>> projectGroupMap = new HashMap<String, ArrayList<String>>();
 	Element rootNode = extFileRootElement;
 	NodeList projectList =  rootNode.getElementsByTagName(ExtXMLHelper.EXTENSION);
@@ -259,10 +259,10 @@
 
 	    if(projectGroupMap.containsKey(group)){
-		ArrayList alist = (ArrayList)projectGroupMap.get(group);
+		ArrayList<String> alist = projectGroupMap.get(group);
 		alist.add(name);
 		projectGroupMap.put(group, alist);
 	    }
 	    else{
-		ArrayList alist = new ArrayList();
+		ArrayList<String> alist = new ArrayList<String>();
 		alist.add(name);
 		projectGroupMap.put(group, alist);
@@ -286,5 +286,5 @@
 	    }
 
-	    ExtensionInformation info = (ExtensionInformation)extensions.get(option);
+	    ExtensionInformation info = extensions.get(option);
 
 	    if(info != null){
@@ -488,5 +488,5 @@
     	JPanel buttonPane = new JPanel();
 
-	ExtensionInformation extension = (ExtensionInformation)extensions.get(projectName);
+	ExtensionInformation extension = extensions.get(projectName);
 
 	String gsdl3ExtHome = GAI.getGSDL3ExtensionHome();
Index: /main/trunk/greenstone3/src/java/org/greenstone/admin/guiext/ExtensionInformation.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/admin/guiext/ExtensionInformation.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/admin/guiext/ExtensionInformation.java	(revision 25635)
@@ -78,5 +78,5 @@
 	//Load the dynamic jar loader
 	URLClassLoader sysloader = (URLClassLoader) ClassLoader.getSystemClassLoader();
-	Class sysclass = URLClassLoader.class;
+	Class<URLClassLoader> sysclass = URLClassLoader.class;
 	final Class[] parameters = new Class[]{URL.class};
 	Method method = null;
Index: /main/trunk/greenstone3/src/java/org/greenstone/admin/guiext/PropertiesStep.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/admin/guiext/PropertiesStep.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/admin/guiext/PropertiesStep.java	(revision 25635)
@@ -60,5 +60,5 @@
     OptionList[] _modifiedOptionLists = null;
     
-    HashMap _optionListTableMap = new HashMap();
+    HashMap<OptionList, PropertyTable> _optionListTableMap = new HashMap<OptionList, PropertyTable>();
 
     public PropertiesStep(Element propertiesStepElement, SequenceList parent)
@@ -106,5 +106,5 @@
     public JTable getTableFromOptionList(OptionList list)
     {
-	return ((JTable)_optionListTableMap.get(list));
+	return _optionListTableMap.get(list);
     }
 
@@ -565,5 +565,5 @@
 
 
-        public Class getColumnClass(int c) {
+        public Class<? extends Object> getColumnClass(int c) {
             return getValueAt(0, c).getClass();
         }
Index: /main/trunk/greenstone3/src/java/org/greenstone/admin/guiext/SequenceList.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/admin/guiext/SequenceList.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/admin/guiext/SequenceList.java	(revision 25635)
@@ -16,5 +16,5 @@
 public class SequenceList
 {
-    protected ArrayList _steps = new ArrayList();
+    protected ArrayList<Step> _steps = new ArrayList<Step>();
     protected ExtensionInformation _parent = null;
     protected Properties _dependencies = null;
@@ -77,5 +77,5 @@
     public Step[] getSteps()
     {
-	return (Step[])(_steps.toArray(new Step[0]));
+	return (_steps.toArray(new Step[0]));
     }
 
@@ -89,5 +89,5 @@
 	JButton[] buttons = new JButton[_steps.size()];
 	for(int i = 0; i < _steps.size(); i++){
-	    buttons[i] = ((Step)_steps.get(i)).getButton();
+	    buttons[i] = _steps.get(i).getButton();
 	}
 	
@@ -152,15 +152,15 @@
     {
 	Step rollbackStep = null;
-	ArrayList dependsSteps = new ArrayList();
-	for(int i = 0; i < _steps.size(); i++){
-	    if(((Step)(_steps.get(i))).getId().equals(id)){
-		rollbackStep = (Step)_steps.get(i);
+	ArrayList<String> dependsSteps = new ArrayList<String>();
+	for(int i = 0; i < _steps.size(); i++){
+	    if((_steps.get(i)).getId().equals(id)){
+		rollbackStep = _steps.get(i);
 	    }
 	    
-	    String[] depends = ((Step)_steps.get(i)).getDependsOn().split(",");
+	    String[] depends = _steps.get(i).getDependsOn().split(",");
 
 	    for(int j = 0; j < depends.length; j++){
 		if(depends[j].equals(id)){
-		    dependsSteps.add(((Step)_steps.get(i)).getId());
+		    dependsSteps.add(_steps.get(i).getId());
 		}
 	    }
@@ -170,5 +170,5 @@
 
 	for(int i = 0; i < dependsSteps.size(); i++){
-	    rollbackToRecursive((String)dependsSteps.get(i));
+	    rollbackToRecursive(dependsSteps.get(i));
 	}
     }
@@ -177,5 +177,5 @@
     {
 	for(int i = 0; i < _steps.size(); i++){
-	    Step currentStep = (Step)_steps.get(i);
+	    Step currentStep = _steps.get(i);
 	    if(currentStep instanceof PropertiesStep){
 		((PropertiesStep)currentStep).setPropertiesToDefaults();
@@ -211,5 +211,5 @@
 	
 	for(int i = 0; i < _steps.size(); i++){
-	    Step currentStep = (Step)_steps.get(i);
+	    Step currentStep = _steps.get(i);
 	    JButton currentButton = currentStep.getButton();
 
Index: /main/trunk/greenstone3/src/java/org/greenstone/applet/phind/ResultCanvas.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/applet/phind/ResultCanvas.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/applet/phind/ResultCanvas.java	(revision 25635)
@@ -76,5 +76,5 @@
     int firstItemDisplayed;
     int itemSelected;
-    Vector items;
+    Vector<ResultItem> items;
     
     // the background image
@@ -95,5 +95,5 @@
 	lineSpacing = phind.fontSize + 2;
 
-	items = new Vector();
+	items = new Vector<ResultItem>();
 	numberOfItems = 0;
 	firstItemDisplayed = 0;
@@ -132,7 +132,7 @@
 	int index = 0;
 	while ((index < numberOfItems) &&
-	       ((item.sort < ((ResultItem) items.elementAt(index)).sort) ||
-		((item.sort == ((ResultItem) items.elementAt(index)).sort) &&
-		 (item.frequency <= ((ResultItem) items.elementAt(index)).frequency)))) {
+	       ((item.sort < items.elementAt(index).sort) ||
+		((item.sort == items.elementAt(index).sort) &&
+		 (item.frequency <= items.elementAt(index).frequency)))) {
 	    index++;
 	}
@@ -160,5 +160,5 @@
 	int index = 0;
 	while (!found && (index < numberOfItems)) {
-	    if (((ResultItem) items.elementAt(index)).isMorePhrases()) {
+	    if (items.elementAt(index).isMorePhrases()) {
 		found = true;
 	    } else {
@@ -192,5 +192,5 @@
 	int index = 0;
 	while (!found && (index < numberOfItems)) {
-	    if (((ResultItem) items.elementAt(index)).isMoreDocuments()) {
+	    if (items.elementAt(index).isMoreDocuments()) {
 		found = true;
 	    } else {
@@ -225,5 +225,5 @@
 	int index = 0;
 	while (!found && (index < numberOfItems)) {
-	    if (((ResultItem) items.elementAt(index)).isMoreLinks()) {
+	    if (items.elementAt(index).isMoreLinks()) {
 		found = true;
 	    } else {
@@ -332,5 +332,5 @@
 
 	    // Get the resultItem to output
-	    result = (ResultItem) items.elementAt(i);
+	    result = items.elementAt(i);
 	    
 	    // Graphics settings for drawing this line
@@ -436,5 +436,5 @@
 	    
 	    // Get the resultItem to output
-	    result = (ResultItem) items.elementAt(i);
+	    result = items.elementAt(i);
 	    docsText = result.docsText();
 	    freqText = result.freqText();
@@ -495,5 +495,5 @@
 	int rowSelected = event.getY() / lineSpacing;
 	itemSelected = rowSelected + firstItemDisplayed;
-	ResultItem item = (ResultItem) items.elementAt(itemSelected);
+	ResultItem item = items.elementAt(itemSelected);
 
 	if (itemSelected <= numberOfItems) {
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/Library2.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/Library2.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/Library2.java	(revision 25635)
@@ -47,5 +47,5 @@
 	protected Document doc = null;
 
-	protected HashMap saved_args = null;
+	protected HashMap<String, String> saved_args = null;
 	protected GSParams params = null;
 	protected DefaultReceptionist recept = null;
@@ -55,5 +55,5 @@
 		this.converter = new XMLConverter();
 		this.doc = converter.newDOM();
-		this.saved_args = new HashMap();
+		this.saved_args = new HashMap<String, String>();
 		this.params = new GSParams();
 		this.recept = new DefaultReceptionist();
@@ -63,5 +63,5 @@
 	{
 
-		HashMap config_params = new HashMap();
+		HashMap<String, Comparable> config_params = new HashMap<String, Comparable>();
 		//config_params.put(GSConstants.GSDL3_HOME, gsdl_home);
 		config_params.put(GSConstants.SITE_NAME, site_name);
@@ -140,5 +140,5 @@
 		String action = "p";
 		String subaction = "home";
-		String lang = (String) saved_args.get(GSParams.LANGUAGE);
+		String lang = saved_args.get(GSParams.LANGUAGE);
 		if (lang == null)
 		{
@@ -193,14 +193,14 @@
 
 		// put in all the params from the session cache
-		Set params = saved_args.keySet();
-		Iterator i = params.iterator();
+		Set<String> params = saved_args.keySet();
+		Iterator<String> i = params.iterator();
 		while (i.hasNext())
 		{
-			String name = (String) i.next();
+			String name = i.next();
 			if (name.equals(GSParams.LANGUAGE))
 				continue;
 			Element param = this.doc.createElement(GSXML.PARAM_ELEM);
 			param.setAttribute(GSXML.NAME_ATT, name);
-			param.setAttribute(GSXML.VALUE_ATT, GSXML.xmlSafe((String) saved_args.get(name)));
+			param.setAttribute(GSXML.VALUE_ATT, GSXML.xmlSafe(saved_args.get(name)));
 			xml_param_list.appendChild(param);
 		}
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/LibraryServlet.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/LibraryServlet.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/LibraryServlet.java	(revision 25635)
@@ -11,4 +11,5 @@
 import org.w3c.dom.NodeList;
 import java.io.*;
+
 import javax.servlet.*;
 import javax.servlet.http.*;
@@ -90,5 +91,5 @@
 	 * form: sid -> (UserSessionCache object)
 	 */
-	protected Hashtable session_ids_table = new Hashtable();
+	protected Hashtable<String, UserSessionCache> session_ids_table = new Hashtable<String, UserSessionCache>();
 
 	/**
@@ -156,5 +157,5 @@
 		}
 
-		HashMap config_params = new HashMap();
+		HashMap<String, Comparable> config_params = new HashMap<String, Comparable>();
 
 		config_params.put(GSConstants.LIBRARY_NAME, library_name);
@@ -310,7 +311,7 @@
 		 * param_value)
 		 */
-		protected Hashtable coll_name_params_table = null;
-
-		public UserSessionCache(String id, Hashtable table)
+		protected Hashtable<String, Hashtable<String, String>> coll_name_params_table = null;
+
+		public UserSessionCache(String id, Hashtable<String, Hashtable<String, String>> table)
 		{
 			session_id = id;
@@ -326,5 +327,5 @@
 		}
 
-		protected Hashtable getParamsTable()
+		protected Hashtable<String, Hashtable<String, String>> getParamsTable()
 		{
 			return coll_name_params_table;
@@ -517,5 +518,5 @@
 			if (clean_all)
 			{
-				session_ids_table = new Hashtable();
+				session_ids_table = new Hashtable<String, UserSessionCache>();
 				session.removeAttribute(GSXML.USER_SESSION_CACHE_ATT);
 			}
@@ -523,8 +524,8 @@
 			{
 				// just clean up info for clean_collection
-				ArrayList cache_list = new ArrayList(session_ids_table.values());
+				ArrayList<UserSessionCache> cache_list = new ArrayList<UserSessionCache>(session_ids_table.values());
 				for (int i = 0; i < cache_list.size(); i++)
 				{
-					UserSessionCache cache = (UserSessionCache) cache_list.get(i);
+					UserSessionCache cache = cache_list.get(i);
 					cache.cleanupCache(clean_collection);
 				}
@@ -555,6 +556,6 @@
 
 		UserSessionCache session_cache = null;
-		Hashtable param_table = null;
-		Hashtable table = null;
+		Hashtable<String, Hashtable<String, String>> param_table = null;
+		Hashtable<String, String> table = null;
 		String sid = session.getId();
 		if (should_cache == true && cache_key != null && !cache_key.equals(""))
@@ -562,5 +563,5 @@
 			if (session_ids_table.containsKey(sid))
 			{
-				session_cache = (UserSessionCache) session_ids_table.get(sid);
+				session_cache = session_ids_table.get(sid);
 				param_table = session_cache.getParamsTable();
 				logger.info("collections in table: " + tableToString(param_table));
@@ -568,9 +569,9 @@
 				{
 					//logger.info("existing table: " + collection);
-					table = (Hashtable) param_table.get(cache_key);
+					table = param_table.get(cache_key);
 				}
 				else
 				{
-					table = new Hashtable();
+					table = new Hashtable<String, String>();
 					param_table.put(cache_key, table);
 					//logger.info("new table: " + collection);
@@ -579,6 +580,6 @@
 			else
 			{
-				param_table = new Hashtable();
-				table = new Hashtable();
+				param_table = new Hashtable<String, Hashtable<String, String>>();
+				table = new Hashtable<String, String>();
 				param_table.put(cache_key, table);
 				session_cache = new UserSessionCache(sid, param_table);
@@ -642,9 +643,9 @@
 			if (table != null)
 			{
-				Enumeration keys = table.keys();
+				Enumeration<String> keys = table.keys();
 				while (keys.hasMoreElements())
 				{
-					String name = (String) keys.nextElement();
-					session.setAttribute(name, (String) table.get(name));
+					String name = keys.nextElement();
+					session.setAttribute(name, table.get(name));
 				}
 			}
@@ -691,5 +692,5 @@
 				for (int j = 0; j < httpHeaders.size(); j++)
 				{
-					Map nameValueMap = (Map) httpHeaders.get(j);
+					Map nameValueMap = httpHeaders.get(j);
 					String name = (String) nameValueMap.get("name");
 					String value = (String) nameValueMap.get("value");
@@ -825,5 +826,5 @@
 			else
 			{
-				HashMap responseParams = GSXML.extractParams(responseParamList, true);
+				HashMap<String, Serializable> responseParams = GSXML.extractParams(responseParamList, true);
 				String groups = (String) responseParams.get(GSXML.GROUPS_ATT);
 
@@ -910,5 +911,5 @@
 
 	//a debugging method
-	private void displaySize(Hashtable table)
+	private void displaySize(Hashtable<String, UserSessionCache> table)
 	{
 		if (table == null)
@@ -923,8 +924,8 @@
 		}
 		int num_cached_coll = 0;
-		ArrayList cache_list = new ArrayList(table.values());
+		ArrayList<UserSessionCache> cache_list = new ArrayList<UserSessionCache>(table.values());
 		for (int i = 0; i < cache_list.size(); i++)
 		{
-			num_cached_coll += ((UserSessionCache) cache_list.get(i)).tableSize();
+			num_cached_coll += cache_list.get(i).tableSize();
 		}
 		logger.info("Number of sessions : total number of cached collection info = " + table.size() + " : " + num_cached_coll);
@@ -932,11 +933,11 @@
 
 	/** merely a debugging method! */
-	private String tableToString(Hashtable table)
+	private String tableToString(Hashtable<String, Hashtable<String, String>> table)
 	{
 		String str = "";
-		Enumeration keys = table.keys();
+		Enumeration<String> keys = table.keys();
 		while (keys.hasMoreElements())
 		{
-			String name = (String) keys.nextElement();
+			String name = keys.nextElement();
 			str += name + ", ";
 		}
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/OAIServer.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/OAIServer.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/OAIServer.java	(revision 25635)
@@ -71,7 +71,7 @@
   
   /** A HashSet which contains all the legal verbs. */
-  protected HashSet verb_set = null;
+  protected HashSet<String> verb_set = null;
   /** A HashSet which contains all the legal oai keys in the key/value argument pair. */
-  protected HashSet param_set = null;
+  protected HashSet<String> param_set = null;
   /** The name of the site with which we will finally be dealing, whether it is a local site or a remote site through a communicator.*/
   protected String site = "";
@@ -209,5 +209,5 @@
   }
   private void initVerbs() {
-    verb_set = new HashSet();
+    verb_set = new HashSet<String>();
     verb_set.add(OAIXML.GET_RECORD);
     verb_set.add(OAIXML.LIST_RECORDS);
@@ -219,5 +219,5 @@
   
   private void initParams() {
-    param_set = new HashSet();
+    param_set = new HashSet<String>();
     param_set.add(OAIXML.METADATA_PREFIX);
     param_set.add(OAIXML.FROM);
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/Action.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/Action.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/Action.java	(revision 25635)
@@ -23,5 +23,5 @@
 
 	/** the system set up variables */
-	protected HashMap config_params = null;
+	protected HashMap<String, Comparable> config_params = null;
 	/** container Document to create XML Nodes */
 	protected Document doc = null;
@@ -43,5 +43,5 @@
 
 	/** the config variables must be set before configure is called */
-	public void setConfigParams(HashMap params)
+	public void setConfigParams(HashMap<String, Comparable> params)
 	{
 		this.config_params = params;
@@ -92,5 +92,5 @@
 	}
 
-	protected void getRequiredMetadataNames(Element format, HashSet meta_names)
+	protected void getRequiredMetadataNames(Element format, HashSet<String> meta_names)
 	{
 		extractMetadataNames(format, meta_names);
@@ -98,5 +98,5 @@
 	}
 
-	protected void extractMetadataNames(Element format, HashSet meta_names)
+	protected void extractMetadataNames(Element format, HashSet<String> meta_names)
 	{
 		//NodeList nodes = format.getElementsByTagNameNS("metadata", "http://www.greenstone.org/configformat");
@@ -133,5 +133,5 @@
 	}
 
-	protected void addLinkMetadataNames(Element format, HashSet meta_names)
+	protected void addLinkMetadataNames(Element format, HashSet<String> meta_names)
 	{
 		// The XSL tranform for
@@ -187,13 +187,13 @@
 	}
 
-	protected Element createMetadataParamList(HashSet metadata_names)
+	protected Element createMetadataParamList(HashSet<String> metadata_names)
 	{
 		Element param_list = this.doc.createElement(GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
 
 		Element param = null;
-		Iterator i = metadata_names.iterator();
+		Iterator<String> i = metadata_names.iterator();
 		while (i.hasNext())
 		{
-			String name = (String) i.next();
+			String name = i.next();
 			param = this.doc.createElement(GSXML.PARAM_ELEM);
 			param_list.appendChild(param);
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/AppletAction.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/AppletAction.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/AppletAction.java	(revision 25635)
@@ -11,4 +11,5 @@
 import java.util.HashMap;
 import java.io.File;
+import java.io.Serializable;
 
 import org.apache.log4j.*;
@@ -32,5 +33,5 @@
 		// get the collection and service params
 		Element cgi_param_list = (Element) GSXML.getChildByTagName(request, GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
-		HashMap params = GSXML.extractParams(cgi_param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(cgi_param_list, false);
 
 		// request_type is display (d) or request (r)
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/BrowseAction.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/BrowseAction.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/BrowseAction.java	(revision 25635)
@@ -13,4 +13,5 @@
 import java.util.Vector;
 import java.io.File;
+import java.io.Serializable;
 
 import org.apache.log4j.*;
@@ -47,5 +48,5 @@
 	// extract the params from the cgi-request, and check that we have a coll specified
 	Element cgi_paramList = (Element)GSXML.getChildByTagName(request, GSXML.PARAM_ELEM+GSXML.LIST_MODIFIER);
-	HashMap params = GSXML.extractParams(cgi_paramList, false);
+	HashMap<String, Serializable> params = GSXML.extractParams(cgi_paramList, false);
 
 	String service_name = (String)params.get(GSParams.SERVICE);
@@ -112,5 +113,5 @@
 	String top_id = OID.getTop(classifier_node);
 	
-	HashSet metadata_names = new HashSet();
+	HashSet<String> metadata_names = new HashSet<String>();
 
 	// add the format info into the response
